## heaptrack 1.5.0+dfsg1

=== CMakeLists.txt ===
if (CMAKE_VERSION VERSION_LESS "2.8.12")
    cmake_minimum_required(VERSION 2.8.9)
    set(HEAPTRACK_BUILD_GUI OFF)
elseif (CMAKE_VERSION VERSION_LESS "3.16.0")
    cmake_minimum_required(VERSION 2.8.12)
else()
    cmake_minimum_required(VERSION 3.16.0)
endif()

project(heaptrack)
enable_testing()

if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build." FORCE)
endif()

set(HEAPTRACK_VERSION_MAJOR 1)
set(HEAPTRACK_VERSION_MINOR 5)
set(HEAPTRACK_VERSION_PATCH 0)
set(HEAPTRACK_LIB_VERSION 1.5.0)
set(HEAPTRACK_LIB_SOVERSION 2)
set(HEAPTRACK_FILE_FORMAT_VERSION 3)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

option(APPIMAGE_BUILD "configure build for bundling in an appimage" OFF)

set(REQUIRED_IN_APPIMAGE "")
if (APPIMAGE_BUILD)
    set(REQUIRED_IN_APPIMAGE REQUIRED)
endif()

include(FeatureSummary)
find_package(Boost 1.60.0 ${REQUIRED_IN_APPIMAGE} COMPONENTS system filesystem iostreams container)
set_package_properties(Boost PROPERTIES TYPE RECOMMENDED PURPOSE "Boost container libraries can greatly improve performance (via pmr allocators)")
find_package(Threads REQUIRED)
find_package(ZLIB REQUIRED)

if (${Boost_IOSTREAMS_FOUND})
    find_package(ZSTD ${REQUIRED_IN_APPIMAGE})

    include(CheckCXXSourceCompiles)
    include(CMakePushCheckState)
    cmake_push_check_state()
    set(CMAKE_REQUIRED_INCLUDES ${Boost_INCLUDE_DIRS})
    set(CMAKE_REQUIRED_LIBRARIES ${Boost_LIBRARIES})
    check_cxx_source_compiles("#include <boost/iostreams/filter/zstd.hpp>
        int main() { boost::iostreams::zstd_decompressor(); return 0; }"
        BOOST_IOSTREAMS_HAS_ZSTD
    )
    cmake_pop_check_state()
endif()
set_package_properties(ZSTD PROPERTIES TYPE RECOMMENDED PURPOSE "Zstandard offers better (de)compression performance compared with gzip/zlib, making heaptrack faster and datafiles smaller.")

if (CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    set(HEAPTRACK_BUILD_TRACK_DEFAULT ON)
    set(HEAPTRACK_BUILD_INTERPRET_DEFAULT ON)
else()
    set(HEAPTRACK_BUILD_TRACK_DEFAULT OFF)
    set(HEAPTRACK_BUILD_INTERPRET_DEFAULT OFF)
endif()

option(
  HEAPTRACK_BUILD_TRACK
  "Disable this option to skip building the tracker part for heaptrack, e.g. to only build the GUI."
  ${HEAPTRACK_BUILD_TRACK_DEFAULT}
)

option(
  HEAPTRACK_BUILD_INTERPRET
  "Disable this option to skip building the interpret part for heaptrack."
  ${HEAPTRACK_BUILD_INTERPRET_DEFAULT}
)

if (CMAKE_CROSSCOMPILING)
    set(HEAPTRACK_BUILD_ANALYZE_DEFAULT OFF)
else()
    set(HEAPTRACK_BUILD_ANALYZE_DEFAULT ON)
endif()

option(
  HEAPTRACK_BUILD_PRINT
  "Disable this option to skip building heaptrack_print, e.g. when you're cross-compiling."
  ${HEAPTRACK_BUILD_ANALYZE_DEFAULT}
)

option(
  HEAPTRACK_BUILD_GUI
  "Disable this option to skip building the Qt / KDE Frameworks based GUI for heaptrack."
  ${HEAPTRACK_BUILD_ANALYZE_DEFAULT}
)

option(
  HEAPTRACK_USE_QT6
  "Use Qt6/KF6 when building the Qt / KDE Frameworks based GUI for heaptrack."
  OFF
)
if(HEAPTRACK_USE_QT6)
    set(QT_VERSION_MAJOR 6)
    # possibly works with older Qt6, but I didn't test that yet
    set(QT_MIN_VERSION 6.5.0)
else()
    set(QT_VERSION_MAJOR 5)
    set(QT_MIN_VERSION 5.10.0)
endif()

option(
  HEAPTRACK_USE_LIBUNWIND
  "Define preferred unwind functionality - Libunwind as ON and unwind_tables as OFF."
  ON
)

set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

if (NOT MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wpedantic")
endif()

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)

include (CheckCXXSourceCompiles)

# cfree() does not exist in glibc 2.26+.
# See: https://bugs.kde.org/show_bug.cgi?id=383889
include(CheckSymbolExists)
check_symbol_exists(cfree malloc.h HAVE_CFREE)
check_symbol_exists(valloc stdlib.h HAVE_VALLOC)

set(BIN_INSTALL_DIR "bin")
set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
set(LIB_INSTALL_DIR "lib${LIB_SUFFIX}")
set(LIBEXEC_INSTALL_DIR "${LIB_INSTALL_DIR}/heaptrack/libexec")

file(RELATIVE_PATH LIBEXEC_REL_PATH
    "${CMAKE_INSTALL_PREFIX}/${BIN_INSTALL_DIR}"
    "${CMAKE_INSTALL_PREFIX}/${LIBEXEC_INSTALL_DIR}")

file(RELATIVE_PATH LIB_REL_PATH
    "${CMAKE_INSTALL_PREFIX}/${BIN_INSTALL_DIR}"
    "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}/heaptrack")

set(ECM_ENABLE_SANITIZERS "" CACHE STRING "semicolon-separated list of sanitizers to enable for code that is not injected into client applications")

if (ECM_ENABLE_SANITIZERS)
    find_package(ECM 1.0.0 NO_MODULE)
    if (ECM_FOUND)
        set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})
    endif()
endif()

if (HEAPTRACK_BUILD_TRACK)
    if (HEAPTRACK_USE_LIBUNWIND)
        find_package(Libunwind REQUIRED)
    endif()

    check_cxx_source_compiles(
        "#ifdef __linux__
        #include <stdio_ext.h>
        #endif
        #include <fcntl.h>
        #include <dlfcn.h>
        #include <link.h>
        int main() { return 0; }"
        HAVE_LINUX_HEADERS)

    if (NOT HAVE_LINUX_HEADERS)
        message(FATAL_ERROR "You are missing some Linux/BSD headers required to compile heaptrack.")
    endif()
endif()

add_subdirectory(3rdparty)
add_subdirectory(src)
add_subdirectory(tests)

# Let releaseme know about this:
# SKIP_PO_INSTALL
# (KF5I18n is optional in src/analyze/CMakeLists.txt...)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/analyze/CMakeLists.txt ===
if (ECM_FOUND)
    include(ECMEnableSanitizers)
endif()

find_package(Boost 1.41.0 REQUIRED COMPONENTS iostreams program_options system filesystem)

configure_file(analyze_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/analyze_config.h)

include_directories(
    ${Boost_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}/3rdparty/
    ${CMAKE_CURRENT_BINARY_DIR}
)

add_library(sharedprint STATIC
    accumulatedtracedata.cpp
    suppressions.cpp
)

target_link_libraries(sharedprint
    PUBLIC
        ${Boost_LIBRARIES}
        ${ZLIB_LIBRARIES}
        tsl::robin_map
)

if (ZSTD_FOUND AND NOT BOOST_IOSTREAMS_HAS_ZSTD)
    target_link_libraries(sharedprint LINK_PUBLIC
        boost-zstd
    )
endif()

add_subdirectory(print)

if(HEAPTRACK_BUILD_GUI)
    find_package(Qt${QT_VERSION_MAJOR} ${QT_MIN_VERSION} ${REQUIRED_IN_APPIMAGE} NO_MODULE OPTIONAL_COMPONENTS Widgets)
    set_package_properties(Qt${QT_VERSION_MAJOR} PROPERTIES TYPE RECOMMENDED PURPOSE "Required for the heaptrack_gui executable.")
    find_package(ECM 1.0.0 ${REQUIRED_IN_APPIMAGE} NO_MODULE)
    set_package_properties(ECM PROPERTIES TYPE RECOMMENDED PURPOSE "KDE's extra-cmake-modules, required for the heaptrack_gui executable.")
    if(Qt${QT_VERSION_MAJOR}_FOUND AND ECM_FOUND)
        set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})
            find_package(KF${QT_VERSION_MAJOR} ${REQUIRED_IN_APPIMAGE} COMPONENTS CoreAddons I18n ItemModels ThreadWeaver ConfigWidgets KIO IconThemes)
            find_package(KChart ${REQUIRED_IN_APPIMAGE} "2.6.0")
            set_package_properties(KChart PROPERTIES TYPE RECOMMENDED PURPOSE "Required for the heaptrack_gui executable. Get it from the kdiagram module.")
        if(KF${QT_VERSION_MAJOR}I18n_FOUND)
            ki18n_install(../../po)
        endif()
    else()
        message(WARNING "Required Qt/KF dependencies for building heaptrack GUI not found")
    endif()
endif()

if (KF${QT_VERSION_MAJOR}_FOUND)
    add_subdirectory(gui)
endif()

=== src/interpret/CMakeLists.txt ===
if (ECM_FOUND)
    include(ECMEnableSanitizers)
endif()

find_package(Elfutils 0.158 REQUIRED)

include_directories(
    ${PROJECT_SOURCE_DIR}/3rdparty/
)

add_definitions("-DHAVE_STDINT_H")

add_executable(heaptrack_interpret
    heaptrack_interpret.cpp
    dwarfdiecache.cpp
    symbolcache.cpp
)

target_link_libraries(heaptrack_interpret
    PRIVATE ${LIBDW_LIBRARIES} tsl::robin_map
)

target_include_directories(heaptrack_interpret
    PRIVATE ${LIBDW_INCLUDE_DIRS}
)

install(TARGETS heaptrack_interpret
    RUNTIME DESTINATION ${LIBEXEC_INSTALL_DIR}
)

set_target_properties(heaptrack_interpret PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIBEXEC_INSTALL_DIR}"
)

=== src/track/CMakeLists.txt ===
# heaptrack: bash script to inject/preload
configure_file(heaptrack.sh.cmake
    ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/heaptrack @ONLY
)

install(PROGRAMS ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/heaptrack
    DESTINATION ${BIN_INSTALL_DIR}
)

if (HEAPTRACK_USE_LIBUNWIND)
    add_library(heaptrack_unwind STATIC trace_libunwind.cpp)
    target_include_directories(heaptrack_unwind PRIVATE ${LIBUNWIND_INCLUDE_DIRS})
    target_link_libraries(heaptrack_unwind PRIVATE ${LIBUNWIND_LIBRARIES})
else()
    add_library(heaptrack_unwind STATIC trace_unwind_tables.cpp)
endif()

if (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    set(LIBUTIL_LIBRARY "util")
endif()

set_property(TARGET heaptrack_unwind PROPERTY POSITION_INDEPENDENT_CODE ON)

# heaptrack_env: runtime environment tests
add_executable(heaptrack_env heaptrack_env.cpp)

install(TARGETS heaptrack_env
    RUNTIME DESTINATION ${LIBEXEC_INSTALL_DIR}
)

set_target_properties(heaptrack_env PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIBEXEC_INSTALL_DIR}"
)

# heaptrack_preload: track a newly started process
add_library(heaptrack_preload MODULE
    heaptrack_preload.cpp
    libheaptrack.cpp
)

target_link_libraries(heaptrack_preload LINK_PRIVATE
    ${CMAKE_DL_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    ${LIBUTIL_LIBRARY}
    heaptrack_unwind
    rt
)

set_target_properties(heaptrack_preload PROPERTIES
    VERSION ${HEAPTRACK_LIB_VERSION}
    SOVERSION ${HEAPTRACK_LIB_SOVERSION}
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIB_INSTALL_DIR}/heaptrack"
)

install(TARGETS heaptrack_preload
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}/heaptrack/
)

# heaptrack_inject: track an already running process
add_library(heaptrack_inject MODULE
    heaptrack_inject.cpp
    libheaptrack.cpp
)

target_link_libraries(heaptrack_inject PRIVATE
    ${CMAKE_DL_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    ${LIBUTIL_LIBRARY}
    heaptrack_unwind
    rt
    tsl::robin_map
)

set_target_properties(heaptrack_inject PROPERTIES
    VERSION ${HEAPTRACK_LIB_VERSION}
    SOVERSION ${HEAPTRACK_LIB_SOVERSION}
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIB_INSTALL_DIR}/heaptrack"
)

install(TARGETS heaptrack_inject
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}/heaptrack/
)

# public API for custom pool allocators or static binaries
install(FILES heaptrack_api.h
    DESTINATION ${CMAKE_INSTALL_PREFIX}/include
)

=== src/util/CMakeLists.txt ===
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(HEAPTRACK_DEBUG_BUILD 1)
else()
    set(HEAPTRACK_DEBUG_BUILD 0)
endif()

configure_file(config.h.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
)

configure_file(libunwind_config.h.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/libunwind_config.h
)

=== tests/auto/CMakeLists.txt ===

set(CMAKE_BUILD_TYPE Debug)
configure_file(tst_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/tst_config.h @ONLY)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src
    ${CMAKE_CURRENT_BINARY_DIR}/../../src/
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/track
)

if ("${Boost_FILESYSTEM_FOUND}" AND "${Boost_SYSTEM_FOUND}")
    if (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
        set(LIBUTIL_LIBRARY "util")
    endif()

    include_directories(
        ${Boost_INCLUDE_DIRS}
    )
endif()

# tst_inject isn't asan-safe, so include it before we enable sanitizers
add_subdirectory(no_asan)

if (ECM_FOUND)
    include(ECMEnableSanitizers)
endif()

add_executable(tst_trace tst_trace.cpp ../../src/interpret/dwarfdiecache.cpp)
set_target_properties(tst_trace PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
target_link_libraries(tst_trace
    PRIVATE
        heaptrack_unwind
        Threads::Threads
        ${LIBDW_LIBRARIES}
        tsl::robin_map
)
target_include_directories(tst_trace PRIVATE ${LIBDW_INCLUDE_DIRS} )

add_test(NAME tst_trace COMMAND tst_trace)

if ("${Boost_FILESYSTEM_FOUND}" AND "${Boost_SYSTEM_FOUND}")
    add_executable(tst_libheaptrack
        tst_libheaptrack.cpp
        ../../src/track/libheaptrack.cpp)
    set_target_properties(tst_libheaptrack PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
    target_link_libraries(tst_libheaptrack
        LINK_PRIVATE
            ${CMAKE_DL_LIBS}
            ${CMAKE_THREAD_LIBS_INIT}
            ${LIBUTIL_LIBRARY}
            heaptrack_unwind
            rt
            ${Boost_SYSTEM_LIBRARY}
            ${Boost_FILESYSTEM_LIBRARY}
    )
    add_test(NAME tst_libheaptrack COMMAND tst_libheaptrack)

    add_executable(tst_io tst_io.cpp)
    set_target_properties(tst_io PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
    target_link_libraries(tst_io
            ${Boost_SYSTEM_LIBRARY}
            ${Boost_FILESYSTEM_LIBRARY}
    )
    add_test(NAME tst_io COMMAND tst_io)

    if (TARGET heaptrack_gui_private)
        find_package(Qt${QT_VERSION_MAJOR} ${QT_MIN_VERSION} CONFIG OPTIONAL_COMPONENTS Test)
        if (Qt${QT_VERSION_MAJOR}Test_FOUND)
            add_executable(tst_parser tst_parser.cpp)
            set_target_properties(tst_parser PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
            target_link_libraries(tst_parser
                    ${Boost_SYSTEM_LIBRARY}
                    ${Boost_FILESYSTEM_LIBRARY}
                    heaptrack_gui_private
                    Qt${QT_VERSION_MAJOR}::Test
            )
            add_test(NAME tst_parser COMMAND tst_parser)
        endif()
    endif()
endif()

=== tests/benchmarks/CMakeLists.txt ===
include_directories(
    ../..
    ${Boost_INCLUDE_DIRS}
)

include (CheckCXXSourceCompiles)
check_cxx_source_compiles(
    "#include <malloc.h>
    int main() { return mallinfo2().uordblks > 0; }"
    HAVE_MALLOC_H)

if (HAVE_MALLOC_H)
    add_executable(bench_pointermap bench_pointermap.cpp)
    set_target_properties(bench_pointermap PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
    target_link_libraries(bench_pointermap PRIVATE tsl::robin_map)

    add_executable(bench_pointerhash bench_pointerhash.cpp)
    set_target_properties(bench_pointerhash PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
    target_link_libraries(bench_pointerhash PRIVATE tsl::robin_map)

    add_executable(measure_malloc_overhead measure_malloc_overhead.cpp)
    set_target_properties(measure_malloc_overhead PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
endif()

add_executable(bench_linereader bench_linereader.cpp)
set_target_properties(bench_linereader PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")

if (TARGET heaptrack_gui_private)
    add_executable(bench_parser bench_parser.cpp)
    set_target_properties(bench_parser PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
    target_link_libraries(bench_parser sharedprint heaptrack_gui_private)
endif()

if (TARGET Qt${QT_VERSION_MAJOR}::Core AND Boost_CONTAINER_FOUND)
    add_executable(bench_tree bench_tree.cpp)
    set_target_properties(bench_tree PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
    target_include_directories(bench_tree PRIVATE ${Boost_INCLUDE_DIRS})
    target_link_libraries(bench_tree Qt${QT_VERSION_MAJOR}::Core
    ${Boost_CONTAINER_LIBRARY})
endif()

=== src/analyze/gui/CMakeLists.txt ===
set(CMAKE_AUTOMOC 1)

ki18n_wrap_ui(UIFILES
    mainwindow.ui
)

unset(BIN_INSTALL_DIR)
unset(LIB_INSTALL_DIR)
unset(LIBEXEC_INSTALL_DIR)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMAddTests)
include(ECMInstallIcons)
include(ECMAddAppIcon)

configure_file(gui_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/gui_config.h)

add_compile_options(-Wall)

add_definitions(-DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_USE_QSTRINGBUILDER
)

add_library(heaptrack_gui_private STATIC
    util.cpp
    parser.cpp
)
target_link_libraries(heaptrack_gui_private PUBLIC
    KF${QT_VERSION_MAJOR}::I18n
    KF${QT_VERSION_MAJOR}::CoreAddons # KFormat
    KF${QT_VERSION_MAJOR}::ThreadWeaver
    Qt${QT_VERSION_MAJOR}::Core
    sharedprint
    pthread
    ${CMAKE_THREAD_LIBS_INIT}
)
if (BUILD_COVERAGE)
    # FIXME: this should be handled within ECM instead of workarounded here
    target_link_libraries(heaptrack_gui_private PRIVATE -lgcov)
endif()

target_compile_definitions(heaptrack_gui_private PRIVATE TRANSLATION_DOMAIN="heaptrack")

target_include_directories(heaptrack_gui_private PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../
    ${Boost_INCLUDE_DIRS}
)

set(SRCFILES
    gui.cpp
    mainwindow.cpp
    treemodel.cpp
    treeproxy.cpp
    costdelegate.cpp
    costheaderview.cpp
    flamegraph.cpp
    stacksmodel.cpp
    topproxy.cpp
    callercalleemodel.cpp
    proxystyle.cpp
    suppressionsmodel.cpp
    resources.qrc
)

ecm_add_app_icon(SRCFILES ICONS
    ${CMAKE_CURRENT_SOURCE_DIR}/128-heaptrack_app_icon.png
    ${CMAKE_CURRENT_SOURCE_DIR}/512-heaptrack_app_icon.png
)

set(LIBRARIES
    Qt${QT_VERSION_MAJOR}::Widgets
    KF${QT_VERSION_MAJOR}::ItemModels
    KF${QT_VERSION_MAJOR}::ConfigWidgets
    KF${QT_VERSION_MAJOR}::I18n
    KF${QT_VERSION_MAJOR}::KIOWidgets
    KF${QT_VERSION_MAJOR}::IconThemes
    sharedprint
    heaptrack_gui_private
)

if (KChart_FOUND)
    list(APPEND SRCFILES
        chartwidget.cpp
        chartmodel.cpp
        chartproxy.cpp
        histogramwidget.cpp
        histogrammodel.cpp
    )
    list(APPEND LIBRARIES
        KChart
        Qt${QT_VERSION_MAJOR}::Svg
    )
endif()

add_executable(heaptrack_gui
    ${SRCFILES}
    ${UIFILES}
)

target_link_libraries(heaptrack_gui
    ${LIBRARIES}
)

install(TARGETS heaptrack_gui
    ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
)

set_target_properties(heaptrack_gui PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${KDE_INSTALL_BINDIR}"
)

install(PROGRAMS org.kde.heaptrack.desktop
    DESTINATION ${KDE_INSTALL_APPDIR}
)

install(FILES org.kde.heaptrack.appdata.xml
    DESTINATION ${KDE_INSTALL_METAINFODIR}
)

ecm_install_icons(ICONS
  16-apps-heaptrack.png
  22-apps-heaptrack.png
  32-apps-heaptrack.png
  48-apps-heaptrack.png
  64-apps-heaptrack.png
  128-apps-heaptrack.png
  DESTINATION ${KDE_INSTALL_ICONDIR}
  THEME hicolor
)

=== debian/changelog ===
heaptrack (1.5.0+dfsg1-4ubuntu5) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:07:08 +0200

heaptrack (1.5.0+dfsg1-4ubuntu4) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:56:46 +0200

heaptrack (1.5.0+dfsg1-4ubuntu3) plucky; urgency=medium

  * Disable branch protection hardening, it causes errors on arm64
    and likely other archs (LP: #2096816)

 -- Tobias Heider <tobias.heider@canonical.com>  Wed, 29 Jan 2025 16:19:39 +0100

heaptrack (1.5.0+dfsg1-4ubuntu2) plucky; urgency=medium

  * Also disable build time tests on armhf.

 -- Rik Mills <rikmills@kde.org>  Fri, 17 Jan 2025 07:38:00 +0000

heaptrack (1.5.0+dfsg1-4ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/tests: Check whether testbed has zstd installed before
      assuming output file format.

 -- Rik Mills <rikmills@kde.org>  Fri, 17 Jan 2025 07:05:40 +0000

heaptrack (1.5.0+dfsg1-4) unstable; urgency=medium

  * [8b6e5dd] Remove kchart from dependencies. (Closes: #1086479)

 -- Anton Gladky <gladk@debian.org>  Fri, 17 Jan 2025 07:06:30 +0100

heaptrack (1.5.0+dfsg1-3) unstable; urgency=medium

  [ Michael Weghorn ]
  * [47b9a18] Backport upstream commit to fix build with GCC 14
    (Closes: #1075065)

  [ Anton Gladky ]
  * [6ad1299] d/control: set Standards-Version to 4.7.0

 -- Anton Gladky <gladk@debian.org>  Mon, 09 Dec 2024 20:40:45 +0100

heaptrack (1.5.0+dfsg1-2ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:24:09 +0000

heaptrack (1.5.0+dfsg1-2ubuntu2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:34:11 +0000

heaptrack (1.5.0+dfsg1-2ubuntu1) noble; urgency=medium

  * debian/tests: Check whether testbed has zstd installed before
    assuming output file format.

 -- Rik Mills <rikmills@kde.org>  Sun, 31 Dec 2023 14:03:34 +0000

heaptrack (1.5.0+dfsg1-2) unstable; urgency=medium

  * [d2bdd38] Disable one more unreliable test. (Closes: #1056077)

 -- Anton Gladky <gladk@debian.org>  Thu, 28 Dec 2023 22:01:27 +0100

heaptrack (1.5.0+dfsg1-1) unstable; urgency=medium

  * [87afadc] Update d/watch
  * [d7d45cf] Update patches
  * [f9cff18] Add libdw-dev and libboost-container-dev to build-deps
  * [42662f0] Add d/copyright
  * [5dbd47c] Remove d/u/signing-key.asc
  * [374b2a2] New upstream version 1.5.0+dfsg1. (Closes: #1056077)
  * [d71f467] Fix grammar error. (Closes: #1016887)
  * [01181d7] Update standards version to 4.6.2, no changes needed.

 -- Anton Gladky <gladk@debian.org>  Thu, 28 Dec 2023 19:40:57 +0100

=== debian/control ===
Source: heaptrack
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: devel
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               qtbase5-dev,
               qtbase5-dev-tools,
               libkf5kio-dev,
               libkf5configwidgets-dev,
               libkf5threadweaver-dev,
               libkf5itemmodels-dev,
               libkf5i18n-dev,
               libdwarf-dev,
               libelf-dev,
               extra-cmake-modules,
               libunwind-dev,
               libdw-dev,
               libboost-container-dev,
               libboost-iostreams-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               zlib1g-dev,
               libzstd-dev,
               libsparsehash-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/heaptrack
Vcs-Git: https://salsa.debian.org/science-team/heaptrack.git
Homepage: https://github.com/KDE/heaptrack
Rules-Requires-Root: no

Package: heaptrack
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libheaptrack (= ${binary:Version})
Description: heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all calls
 to the core memory allocation functions and logs these occurrences.
 Additionally, backtraces are obtained and logged. It can also
 generate a historigram of allocation sizes over the number of
 calls. Heaptrack measures the following:
 .
   * Heap memory consumption (like Massif).
   * Number of calls to allocation functions (like callgrind).
   * Total amount of memory allocated, ignoring deallocations.
   * Leaked memory (like memcheck).
 .
 Heaptrack is notable for its ability to attach to running processes,
 for consuming substantially less memory than Valgrind, and for not
 reducing an application's interactivity as much as Valgrind does.
 Heaptrack is useful for debugging memory leaks and memory ballooning.
 .
 The package contains the command line tools.

Package: heaptrack-gui
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all calls
 to the core memory allocation functions and logs these occurrences.
 Additionally, backtraces are obtained and logged. It can also
 generate a historigram of allocation sizes over the number of
 calls. Heaptrack measures the following:
 .
   * Heap memory consumption (like Massif).
   * Number of calls to allocation functions (like callgrind).
   * Total amount of memory allocated, ignoring deallocations.
   * Leaked memory (like memcheck).
 .
 Heaptrack is notable for its ability to attach to running processes,
 for consuming substantially less memory than Valgrind, and for not
 reducing an application's interactivity as much as Valgrind does.
 Heaptrack is useful for debugging memory leaks and memory ballooning.
 .
 The package contains the GUI for data analysis.

Package: libheaptrack
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all calls
 to the core memory allocation functions and logs these occurrences.
 Additionally, backtraces are obtained and logged. It can also
 generate a historigram of allocation sizes over the number of
 calls. Heaptrack measures the following:
 .
   * Heap memory consumption (like Massif).
   * Number of calls to allocation functions (like callgrind).
   * Total amount of memory allocated, ignoring deallocations.
   * Leaked memory (like memcheck).
 .
 Heaptrack is notable for its ability to attach to running processes,
 for consuming substantially less memory than Valgrind, and for not
 reducing an application's interactivity as much as Valgrind does.
 Heaptrack is useful for debugging memory leaks and memory ballooning.
 .
 The package contains the shared libraries.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-branch optimize=+lto

BUILDDIR = $(CURDIR)/debian/build

%:
	dh $@ --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- -DHEAPTRACK_BUILD_PRINT=ON -DHEAPTRACK_BUILD_GUI=ON

# Unittests are disabled on mips due to build failures
# It looks like the crash is happening in libunwind,
# needs to be investigated
#
# https://sources.debian.net/src/libunwind/1.1-4.1/debian/rules/#L34
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
ifneq (armhf, $(DEB_HOST_ARCH))
override_dh_auto_install:
	dh_auto_install
	cd $(BUILDDIR) ; $(MAKE) test ARGS=-VV
endif # amd64
endif # nocheck

override_dh_auto_test:

=== debian/watch ===
version=4
opts=repacksuffix=+dfsg1,dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$// \
https://download.kde.org/stable/heaptrack/([\d.]+)/@PACKAGE@-([\d.]+)\.tar\.xz

## heaptrack 1.5.0+dfsg1+git20260219.f16e8d3

=== src/analyze/CMakeLists.txt ===
if (ECM_FOUND)
    include(ECMEnableSanitizers)
endif()

find_package(Boost 1.70.0 CONFIG REQUIRED COMPONENTS iostreams program_options filesystem)

configure_file(analyze_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/analyze_config.h)

include_directories(
    ${Boost_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}/3rdparty/
    ${CMAKE_CURRENT_BINARY_DIR}
)

add_library(sharedprint STATIC
    accumulatedtracedata.cpp
    suppressions.cpp
)

target_link_libraries(sharedprint
    PUBLIC
        ${Boost_LIBRARIES}
        ${ZLIB_LIBRARIES}
        tsl::robin_map
)

if (ZSTD_FOUND AND NOT BOOST_IOSTREAMS_HAS_ZSTD)
    target_link_libraries(sharedprint LINK_PUBLIC
        boost-zstd
    )
endif()

add_subdirectory(print)

if(HEAPTRACK_BUILD_GUI)
    find_package(Qt6 ${QT_MIN_VERSION} ${REQUIRED_IN_APPIMAGE} NO_MODULE OPTIONAL_COMPONENTS Widgets)
    set_package_properties(Qt6 PROPERTIES TYPE RECOMMENDED PURPOSE "Required for the heaptrack_gui executable.")
    find_package(ECM 1.0.0 ${REQUIRED_IN_APPIMAGE} NO_MODULE)
    set_package_properties(ECM PROPERTIES TYPE RECOMMENDED PURPOSE "KDE's extra-cmake-modules, required for the heaptrack_gui executable.")
    if(Qt6_FOUND AND ECM_FOUND)
        set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})
            find_package(KF6 ${REQUIRED_IN_APPIMAGE} COMPONENTS CoreAddons I18n ThreadWeaver ConfigWidgets KIO IconThemes)
            find_package(KChart6 ${REQUIRED_IN_APPIMAGE} "2.6.0")
            set_package_properties(KChart6 PROPERTIES TYPE RECOMMENDED PURPOSE "Required for the heaptrack_gui executable. Get it from the kdiagram module.")
        if(KF6I18n_FOUND)
            ki18n_install(../../po)
        endif()
    else()
        message(WARNING "Required Qt/KF dependencies for building heaptrack GUI not found")
    endif()
endif()

if(KChart6_FOUND)
    set(KChart_FOUND TRUE)
endif()

if (KF6_FOUND)
    add_subdirectory(gui)
endif()

=== src/interpret/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,7 @@
 endif()
 
 find_package(Elfutils 0.158 REQUIRED)
+find_package(Boost 1.70.0 CONFIG REQUIRED COMPONENTS program_options)
 
 include_directories(
     ${PROJECT_SOURCE_DIR}/3rdparty/
@@ -14,14 +15,17 @@
     heaptrack_interpret.cpp
     dwarfdiecache.cpp
     symbolcache.cpp
+    demangler.cpp
 )
 
 target_link_libraries(heaptrack_interpret
     PRIVATE ${LIBDW_LIBRARIES} tsl::robin_map
+    Boost::program_options
+
 )
 
 target_include_directories(heaptrack_interpret
-    PRIVATE ${LIBDW_INCLUDE_DIRS}
+    PRIVATE ${LIBDW_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS}
 )
 
 install(TARGETS heaptrack_interpret
@@ -31,3 +35,17 @@
 set_target_properties(heaptrack_interpret PROPERTIES
     RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIBEXEC_INSTALL_DIR}"
 )
+
+find_package(LibRustcDemangle)
+set_package_properties(LibRustcDemangle PROPERTIES
+        DESCRIPTION "Demangling for Rust symbols, written in Rust."
+        PURPOSE "Demangling of Rust symbols"
+        URL "https://github.com/alexcrichton/rustc-demangle"
+        TYPE RUNTIME)
+
+find_package(LibDDemangle)
+set_package_properties(LibDDemangle PROPERTIES
+        DESCRIPTION "Demangling for D symbols, written in D."
+        PURPOSE "Demangling of D symbols"
+        URL "https://github.com/lievenhey/d_demangler"
+        TYPE RUNTIME)

=== tests/auto/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/../../src/track
 )
 
-if ("${Boost_FILESYSTEM_FOUND}" AND "${Boost_SYSTEM_FOUND}")
+if (Boost_FILESYSTEM_FOUND)
     if (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
         set(LIBUTIL_LIBRARY "util")
     endif()
@@ -28,7 +28,7 @@
     include(ECMEnableSanitizers)
 endif()
 
-add_executable(tst_trace tst_trace.cpp ../../src/interpret/dwarfdiecache.cpp)
+add_executable(tst_trace tst_trace.cpp ../../src/interpret/dwarfdiecache.cpp ../../src/interpret/demangler.cpp)
 set_target_properties(tst_trace PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
 target_link_libraries(tst_trace
     PRIVATE
@@ -41,7 +41,10 @@
 
 add_test(NAME tst_trace COMMAND tst_trace)
 
-if ("${Boost_FILESYSTEM_FOUND}" AND "${Boost_SYSTEM_FOUND}")
+configure_file(tst_heaptrack_interpret.cmake.sh ${CMAKE_CURRENT_BINARY_DIR}/tst_heaptrack_interpret.sh @ONLY)
+add_test(NAME tst_heaptrack_interpret COMMAND ${CMAKE_CURRENT_BINARY_DIR}/tst_heaptrack_interpret.sh)
+
+if (Boost_FILESYSTEM_FOUND)
     add_executable(tst_libheaptrack
         tst_libheaptrack.cpp
         ../../src/track/libheaptrack.cpp)
@@ -53,7 +56,6 @@
             ${LIBUTIL_LIBRARY}
             heaptrack_unwind
             rt
-            ${Boost_SYSTEM_LIBRARY}
             ${Boost_FILESYSTEM_LIBRARY}
     )
     add_test(NAME tst_libheaptrack COMMAND tst_libheaptrack)
@@ -61,21 +63,19 @@
     add_executable(tst_io tst_io.cpp)
     set_target_properties(tst_io PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
     target_link_libraries(tst_io
-            ${Boost_SYSTEM_LIBRARY}
             ${Boost_FILESYSTEM_LIBRARY}
     )
     add_test(NAME tst_io COMMAND tst_io)
 
     if (TARGET heaptrack_gui_private)
-        find_package(Qt${QT_VERSION_MAJOR} ${QT_MIN_VERSION} CONFIG OPTIONAL_COMPONENTS Test)
-        if (Qt${QT_VERSION_MAJOR}Test_FOUND)
+        find_package(Qt6 ${QT_MIN_VERSION} CONFIG OPTIONAL_COMPONENTS Test)
+        if (Qt6Test_FOUND)
             add_executable(tst_parser tst_parser.cpp)
             set_target_properties(tst_parser PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
             target_link_libraries(tst_parser
-                    ${Boost_SYSTEM_LIBRARY}
                     ${Boost_FILESYSTEM_LIBRARY}
                     heaptrack_gui_private
-                    Qt${QT_VERSION_MAJOR}::Test
+                    Qt6::Test
             )
             add_test(NAME tst_parser COMMAND tst_parser)
         endif()

=== tests/auto/no_asan/CMakeLists.txt ===
if (Boost_FILESYSTEM_FOUND)
    add_executable(tst_inject tst_inject.cpp)
    set_target_properties(tst_inject PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
    target_link_libraries(tst_inject
            ${CMAKE_DL_LIBS}
            ${Boost_FILESYSTEM_LIBRARY}
    )
    add_test(NAME tst_inject COMMAND tst_inject)
endif()

=== debian/changelog ===
heaptrack (1.5.0+dfsg1+git20260219.f16e8d3-2) unstable; urgency=medium

  * Team upload.
  * debian/patches/0002-Disable-tst_heaptrack_interpret.patch: Add patch
    to disable tst_heaptrack_interpret to fix ftbfs on 32-bit environments.
    This test is 64-bit only.

 -- Boyuan Yang <byang@debian.org>  Tue, 03 Mar 2026 13:10:05 -0500

heaptrack (1.5.0+dfsg1+git20260219.f16e8d3-1) unstable; urgency=medium

  * Team upload.
  * New upstream git trunk snapshot.
    + Fix compatibility with boost1.89 and later. (really closes: #1127209)
  * debian/control: Use correct homepage field info.
  * debian/control: Drop Ruiles-Requires-Root: no.
  * debian/control: Replace build-dep with kf6 and qt6. (Closes: #1121567)
    + Correctly build with kchart. (LP: #2122578)
  * debian/patches/:
    - 10_update_cmake_version.patch: Dropped, now useless.
    - 30_cmake-Fix-C-compatibility-of-libunwind-probes.patch: Dropped, merged.
  * debian/patches/20_disable_some_unreliable_tests.patch: Refreshed.
  * debian/source/lintian-overrides: Override lintian false positives on
    upstream-provided test artifacts.

 -- Boyuan Yang <byang@debian.org>  Tue, 03 Mar 2026 11:22:40 -0500

heaptrack (1.5.0+dfsg1-6) unstable; urgency=medium

  * Team upload.
  * d/watch: version=5
  * Remove libboost-system-dev from Build-Depends
    Closes: #1127209
  * Standards-Version: 4.7.3 (routine-update)
  * Remove Priority field to comply with Debian Policy 4.7.3 (routine-
    update)
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 17 Feb 2026 23:02:43 +0100

heaptrack (1.5.0+dfsg1-5) unstable; urgency=medium

  * Team upload.
  * [62ffba1] Drop unnecessary B-D libdwarf-dev. (Closes: #1098768)

 -- Bastian Germann <bage@debian.org>  Fri, 28 Feb 2025 23:56:16 +0100

=== debian/control ===
--- 
+++ 
@@ -1,43 +1,43 @@
 Source: heaptrack
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Anton Gladky <gladk@debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders:
+ Anton Gladky <gladk@debian.org>,
 Section: devel
-Priority: optional
-Build-Depends: cmake,
-               debhelper-compat (= 13),
-               qtbase5-dev,
-               qtbase5-dev-tools,
-               libkf5kio-dev,
-               libkf5configwidgets-dev,
-               libkf5threadweaver-dev,
-               libkf5itemmodels-dev,
-               libkf5i18n-dev,
-               libdwarf-dev,
-               libelf-dev,
-               extra-cmake-modules,
-               libunwind-dev,
-               libdw-dev,
-               libboost-container-dev,
-               libboost-iostreams-dev,
-               libboost-filesystem-dev,
-               libboost-system-dev,
-               libboost-program-options-dev,
-               libboost-regex-dev,
-               zlib1g-dev,
-               libzstd-dev,
-               libsparsehash-dev
-Standards-Version: 4.7.0
+Build-Depends:
+ debhelper-compat (= 13),
+ cmake,
+ extra-cmake-modules,
+ libboost-container-dev,
+ libboost-filesystem-dev,
+ libboost-iostreams-dev,
+ libboost-program-options-dev,
+ libboost-regex-dev,
+ libdw-dev,
+ libelf-dev,
+ libkchart-dev,
+ libkf6configwidgets-dev,
+ libkf6i18n-dev,
+ libkf6iconthemes-dev,
+ libkf6itemmodels-dev,
+ libkf6kio-dev,
+ libkf6threadweaver-dev,
+ libsparsehash-dev,
+ libunwind-dev,
+ libzstd-dev,
+ qt6-base-dev,
+ qt6-base-dev-tools,
+ zlib1g-dev,
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/science-team/heaptrack
 Vcs-Git: https://salsa.debian.org/science-team/heaptrack.git
-Homepage: https://github.com/KDE/heaptrack
-Rules-Requires-Root: no
+Homepage: https://invent.kde.org/sdk/heaptrack
 
 Package: heaptrack
 Architecture: any
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         libheaptrack (= ${binary:Version})
+Depends:
+ libheaptrack (= ${binary:Version}),
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: heap memory profiler for Linux
  Heap memory usage profiler. It uses LD_PRELOAD to track all calls
  to the core memory allocation functions and logs these occurrences.
@@ -59,8 +59,9 @@
 
 Package: heaptrack-gui
 Architecture: any
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: heap memory profiler for Linux
  Heap memory usage profiler. It uses LD_PRELOAD to track all calls
  to the core memory allocation functions and logs these occurrences.
@@ -82,8 +83,9 @@
 
 Package: libheaptrack
 Architecture: any
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: heap memory profiler for Linux
  Heap memory usage profiler. It uses LD_PRELOAD to track all calls
  to the core memory allocation functions and logs these occurrences.

## heaptrack 1.5.0+p24.04+vstable+git20250902.0115

=== debian/changelog ===
heaptrack (1.5.0+p24.04+vstable+git20250902.0115-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 02 Sep 2025 01:15:18 +0000

heaptrack (1.5.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 03 Oct 2023 19:18:07 +0000

heaptrack (1.4.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 20 Oct 2022 19:18:08 +0000

## heaptrack 1.5.0+p24.04+vstable+git20250916.2336

=== debian/changelog ===
heaptrack (1.5.0+p24.04+vstable+git20250916.2336-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 16 Sep 2025 23:36:21 +0000
